/**************************************************************************
* fisharium.c: Fisharium v1.0
* An ASCII fishtank hastily put together for GameDev's ASCII Fish contest.
* Copyright (C) 2003 Tim Park (tim@fiction.org)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
* (compile as Win32 Console Application)
**************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <Windows.h>
#include <time.h>
#include "fisharium.h"

// In theory, the tank would be easily resizeable.
// But in practice, some code ignored these near the deadline.
#define TANKWIDTH 58
#define TANKHEIGHT 48
#define WINDOWHEIGHT 26
#define MAXBUTTONS 100
#define NUMNOISE 10
#define NUMSPEECHES 1

struct conf config = {OPTIONS, COLOUR, NOTHING, NOTHING, 0, //modes
  TRUE, FALSE, //sound&music
  FALSE, FALSE, FALSE, FALSE, FALSE }; //dispopts

COORD coord = {80, 50}, coord2 = {0, 0};
SMALL_RECT write = {0, 0, 79, 49};
short numbuttons = 0;
CHAR_INFO chars[80*50];
HANDLE rhnd, whnd;
BUTTON buttons[MAXBUTTONS];

int done = 0;
long frame = 0;
int lowerwaterheight = 0;
DWORD startClockCount = 0;
RECT bounds = { 1, 0, TANKWIDTH-2, TANKHEIGHT-1-2 };

char WhatIsTheMatrix[TANKHEIGHT][TANKWIDTH];
char matrixSpeeds[TANKWIDTH];
char matrixPos[TANKWIDTH];
short fishclrs[5] = {FG_LRED, FG_LGREEN, FG_LBLUE, FG_LYELLOW, FG_LPURPLE};

short silencetime = 200, speaktime = 0, speechflag = 0;
char speak1chrs[80], speak2chrs[80];
CIMAGE speak1text = { BG_NOCHANGE, FG_NOCHANGE, 1, 1, {speak1chrs}};
CIMAGE speak2text = { BG_NOCHANGE, FG_NOCHANGE, 1, 1, {speak2chrs}};
//"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"}};

// UI-related text
CIMAGE mute = { BG_NOCHANGE, FG_LRED, 0, 1, {
"* MUTE *"}};
CIMAGE dot = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"\x07"}};
CIMAGE theX = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"X"}};
CIMAGE title = { BG_NOCHANGE, FG_WHITE, 0, 1, {
"Fisharium v1.0   [X]"}};
CIMAGE topwindow = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"\xda\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xbf"}};
CIMAGE dbltopwindow = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"\xc9\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xcd\xbb"}};
CIMAGE display = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"/1:Display\\"}};
CIMAGE options = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"/2:Options\\"}};
CIMAGE play = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"/3:Play\\"}};
CIMAGE torment = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"/4:Torment\\"}};

// Display-related text
CIMAGE Dcolour = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"( ) Colour"}};
CIMAGE Dblackandwhite = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"( ) Black & White"}};
CIMAGE Ddisco = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"( ) Disco"}};
CIMAGE Dwindows = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"( ) Windows"}};
CIMAGE Dmatrix = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"( ) Matrix"}};

CIMAGE Dsound = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"[ ] Sound"}};
CIMAGE Dmusic = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"[ ] Music"}};

// Options-related text
CIMAGE Daerator = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"[ ] Aerator"}};
CIMAGE Dcastle = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"[ ] Castle"}};
CIMAGE Dplants = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"[ ] Plants"}};
CIMAGE Dtreasure = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"[ ] Treasure"}};
CIMAGE Dtank = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"[ ] Tank"}};

char aeratorlines[43][6] = {
"@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@",
"@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@",
"@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@",
"@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@",
"@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@","@@@@@",
"@@@@@","@@@@@","@@@@@"};

CIMAGE aerator = { BG_NOCHANGE, FG_LWHITE, 0, 43, {
aeratorlines[0],aeratorlines[1],aeratorlines[2],aeratorlines[3],aeratorlines[4],
aeratorlines[5],aeratorlines[6],aeratorlines[7],aeratorlines[8],aeratorlines[9],
aeratorlines[10],aeratorlines[11],aeratorlines[12],aeratorlines[13],aeratorlines[14],
aeratorlines[15],aeratorlines[16],aeratorlines[17],aeratorlines[18],aeratorlines[19],
aeratorlines[20],aeratorlines[21],aeratorlines[22],aeratorlines[23],aeratorlines[24],
aeratorlines[25],aeratorlines[26],aeratorlines[27],aeratorlines[28],aeratorlines[29],
aeratorlines[30],aeratorlines[31],aeratorlines[32],aeratorlines[33],aeratorlines[34],
aeratorlines[35],aeratorlines[36],aeratorlines[37],aeratorlines[38],aeratorlines[39],
aeratorlines[40],aeratorlines[41],aeratorlines[42]}};

CIMAGE Ocastle1 = { BG_CYAN, FG_BLACK, 0, 6, {
"\xc2\xc1\xc2@\xc2\xc1\xc2@\xc2\xc1\xc2",
"\xc1\xc2\xc1\xc2\xc1\xc2\xc1\xc2\xc1\xc2\xc1",
"@\xc1\xc2\xc1\xc2\xc1\xc2\xc1\xc2\xc1",
"@\xc2\xc1\xc2\xc1\xc2\xc1\xc2\xc1\xc2",
"@\xc1\xc2\xc1\xc2\xc1\xc2\xc1\xc2\xc1",
"@\xc2\xc1\xc2\xc1\xc2\xc1\xc2\xc1\xc2"}};

CIMAGE Ocastle2 = { BG_BLACK, FG_CYAN, 0, 6, {
"",
"",
"",
"@@@@\xdf \xdf",
"@@@@   ",
"@@@@   "}};

CIMAGE Ocastle3 = { BG_BLACK, FG_LWHITE, 0, 6, {
"",
"",
"",
"",
"@@@@o@o",
""}};

CIMAGE Oplants = { BG_NOCHANGE, FG_LGREEN, 0, 5, {
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@/",
"@@@@@@@@@.))@@@@{@@@@@@@@@@@@@@@@@@@@@@{@@@@@||@)",
"@@@@@@@@//||@(@@@}@@@@@@@@@@@@@@@@@@@@@@}@(@@\\\\//",
"@@@@@@@@\\\\//@@)@{@@@@@@@@@@@@@@@@@@@@@@{@@@)@@||",
"@@@@@@@@@||@@(@@@}@@@@@@@@@@@@@@@@@@@@@@}@(@@@||"
}};

CIMAGE Otreasure1 = { BG_RED, FG_BLACK, 0, 5, {
"@\xc4\xc4\xc4\xc4\xc4",
"\xc4\xc4\xc4\x1f\xc4\xc4\xc4",
"\xdd     \xde",
"\xc4\xc4\xc4\xc4\xc4\xc4\xc4",
"@\xc4\xc4\xc4\xc4\xc4"}};

CIMAGE Otreasure2 = { BG_RED, FG_LYELLOW, 0, 5, {
"",
"",
"@.ooo.",
"",
""}};

CIMAGE Otank = { BG_BLACK, FG_LWHITE, 0, 5, {
"\xc9\xcd\xcd\xcd\xcd\xcd\xbb",
"\xba \x01 \x01 \xba",
"\xba \xc5 \xc5 \xba",
"\xba ^ ^ \xba",
"\xc8\xcd\xcd\xcd\xcd\xcd\xbc",
}};

// Play-related text
CIMAGE Pfeed = { BG_BLUE, FG_WHITE, 0, 1, {
"   Feed    "}};
CIMAGE Pspeak = { BG_BLUE, FG_WHITE, 0, 1, {
"   Speak   "}};
CIMAGE Ppet = { BG_BLUE, FG_WHITE, 0, 1, {
"    Pet    "}};
CIMAGE Pdance = { BG_BLUE, FG_WHITE, 0, 1, {
"   Dance   "}};
CIMAGE Psleep = { BG_BLUE, FG_WHITE, 0, 1, {
"   Sleep   "}};
CIMAGE Pplaydead = { BG_BLUE, FG_WHITE, 0, 1, {
" Play Dead "}};

CIMAGE Pfeedtext = { BG_BLACK, FG_WHITE, 1, 1, {
"Lhz!"}};
CIMAGE Pspeaktext = { BG_BLACK, FG_WHITE, 1, 1, {
"Jbbs!"}};
CIMAGE Ppettext = { BG_BLACK, FG_WHITE, 1, 1, {
"Lbh jnag gb crg n svfu?  Trg n qbt, ohqql!"}};
CIMAGE Psleeptext = { BG_BLACK, FG_WHITE, 1, 1, {
"Mmm..."}};

// Torment-related text
CIMAGE Tnothing = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"( ) Nothing"}};
CIMAGE Theat = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"( ) Heat"}};
CIMAGE Tcold = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"( ) Cold"}};
CIMAGE Tpoison = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"( ) Poison"}};
CIMAGE Tlowerwater = { BG_NOCHANGE, FG_NOCHANGE, 0, 1, {
"( ) Lower Water"}};

char heatdotlines[43][TANKWIDTH-2+1] = { "" };

CIMAGE heatdots = { BG_NOCHANGE, FG_LWHITE, 0, 43, {
heatdotlines[0],heatdotlines[1],heatdotlines[2],heatdotlines[3],heatdotlines[4],
heatdotlines[5],heatdotlines[6],heatdotlines[7],heatdotlines[8],heatdotlines[9],
heatdotlines[10],heatdotlines[11],heatdotlines[12],heatdotlines[13],heatdotlines[14],
heatdotlines[15],heatdotlines[16],heatdotlines[17],heatdotlines[18],heatdotlines[19],
heatdotlines[20],heatdotlines[21],heatdotlines[22],heatdotlines[23],heatdotlines[24],
heatdotlines[25],heatdotlines[26],heatdotlines[27],heatdotlines[28],heatdotlines[29],
heatdotlines[30],heatdotlines[31],heatdotlines[32],heatdotlines[33],heatdotlines[34],
heatdotlines[35],heatdotlines[36],heatdotlines[37],heatdotlines[38],heatdotlines[39],
heatdotlines[40],heatdotlines[41],heatdotlines[42]}};

// Noise-related text
CIMAGE noise[NUMNOISE] = {
{ BG_NOCHANGE, FG_BLACK, 0, 1, { "/~" }},
{ BG_NOCHANGE, FG_BLACK, 0, 1, { "~\\" }},
{ BG_NOCHANGE, FG_BLACK, 0, 2, { "/", "\\" }},
{ BG_NOCHANGE, FG_BLACK, 0, 2, { "\\", "/" }},
{ BG_NOCHANGE, FG_BLACK, 0, 2, { "@/", "/_" }},
{ BG_NOCHANGE, FG_BLACK, 0, 2, { "\\", "_\\" }},
{ BG_NOCHANGE, FG_BLACK, 0, 2, { "/\\", "@/" }},
{ BG_NOCHANGE, FG_BLACK, 0, 2, { "/\\", "\\" }},
{ BG_NOCHANGE, FG_BLACK, 0, 2, { "/", "\\/" }},
{ BG_NOCHANGE, FG_BLACK, 0, 2, { "@\\", "\\/" }}};

// Fishtank-related text
//LGREEN
CIMAGE drfish = { BG_NOCHANGE, FG_LRED, 0, 4, { //not a real doctor
"@@@_\\\\_@",
"\\\\/  - \\",
"//\\___o/",
"@@@@//"}};
CIMAGE rfish = { BG_NOCHANGE, FG_LRED, 0, 4, {
"@@@_\\\\_@",
"\\\\/  o \\",
"//\\___-/",
"@@@@//"}};
CIMAGE rfish1 = { BG_NOCHANGE, FG_LRED, 0, 4, {
"@@@@_\\_@",
"@@\\/ o \\",
"@@/\\__-/",
"@@@@@/"}};
CIMAGE rfish2 = { BG_NOCHANGE, FG_LRED, 0, 4, {
"@@@@@@,@",
"@@@@@/\xec\\",
"@@@@@\\=/",
"@@@@@@'"}};
CIMAGE rfish3 = { BG_NOCHANGE, FG_LRED, 0, 4, {
"@@@_/_@@",
"@@/ o \\/",
"@@\\-__/\\",
"@@@@\\"}};

CIMAGE dlfish = { BG_NOCHANGE, FG_LRED, 0, 4, {
"@_//_@@@",
"/ -  \\//",
"\\o___/\\\\",
"@@\\\\"}};
CIMAGE lfish = { BG_NOCHANGE, FG_LRED, 0, 4, {
"@_//_@@@",
"/ o  \\//",
"\\-___/\\\\",
"@@\\\\"}};
CIMAGE lfish1 = { BG_NOCHANGE, FG_LRED, 0, 4, {
"@_/_@@@@",
"/ o \\/",
"\\-__/\\",
"@@\\"}};
CIMAGE lfish2 = { BG_NOCHANGE, FG_LRED, 0, 4, {
"@,@@@@@@",
"/\xec\\",
"\\=/",
"@'"}};
CIMAGE lfish3 = { BG_NOCHANGE, FG_LRED, 0, 4, {
"@@_\\_@@@",
"\\/ o \\",
"/\\__-/",
"@@@/"}};

CIMAGE slfish = { BG_NOCHANGE, FG_LYELLOW, 0, 1, {
"<o><"}};
CIMAGE slfish1 = { BG_NOCHANGE, FG_LYELLOW, 0, 1, {
"<><@"}};
CIMAGE slfish2 = { BG_NOCHANGE, FG_LYELLOW, 0, 1, {
"()@@"}};
CIMAGE slfish3 = { BG_NOCHANGE, FG_LYELLOW, 0, 1, {
"><>@"}};

CIMAGE srfish = { BG_NOCHANGE, FG_LYELLOW, 0, 1, {
"><o>"}};
CIMAGE srfish1 = { BG_NOCHANGE, FG_LYELLOW, 0, 1, {
"@><>"}};
CIMAGE srfish2 = { BG_NOCHANGE, FG_LYELLOW, 0, 1, {
"@@()"}};
CIMAGE srfish3 = { BG_NOCHANGE, FG_LYELLOW, 0, 1, {
"@<><"}};

COBJECT fishes[5] = {
{RESTING, LEFT, 10, 10, 10, 0, BG_NOCHANGE, FG_LGREEN, 0, 0, {{0,0}}, &lfish},
{RESTING, LEFT, 10, 20, 20, 0, BG_NOCHANGE, FG_LBLUE, 0, 0, {{0,0}}, &rfish},
{RESTING, LEFT, 10, 30, 30, 0, BG_NOCHANGE, FG_LRED, 0, 0, {{0,0}}, &lfish},
{RESTING, LEFT, 10, 40, 40, 0, BG_NOCHANGE, FG_LYELLOW, 0, 0, {{0,0}}, &srfish},
{RESTING, LEFT, 30, 25, 50, 0, BG_NOCHANGE, FG_LPURPLE, 0, 0, {{0,0}}, &slfish}};

CIMAGE leftfloor1 = { BG_NOCHANGE, FG_BLACK, 0, 4, {
"@@@@@@\xdc\xdb",
"@@@@\xdc\xdb@@",
"@@\xdc\xdb@@@@",
"\xdc\xdb@@@@@@"}};

CIMAGE leftfloor2 = { BG_BLACK, FG_BLACK, 0, 4, {
"@@@@@@@@",
"@@@@@@  ",
"@@@@    ",
"@@      "}};

CIMAGE rightfloor1 = { BG_NOCHANGE, FG_BLACK, 0, 4, {
"\xdb\xdc@@@@@@",
"@@\xdb\xdc@@@@",
"@@@@\xdb\xdc@@",
"@@@@@@\xdb\xdc"}};

CIMAGE rightfloor2 = { BG_BLACK, FG_BLACK, 0, 4, {
"@@@@@@@@",
"  @@@@@@",
"    @@@@",
"      @@"}};

// Disco mode-related text
CIMAGE ULMIdiscofloor = { BG_NOCHANGE, FG_NOCHANGE, 0, 2, {
"@  ", "\xdd  "}};
CIMAGE URMIdiscofloor = { BG_NOCHANGE, FG_NOCHANGE, 0, 2, {
"  @", "  \xde"}};
CIMAGE LLMIdiscofloor = { BG_NOCHANGE, FG_NOCHANGE, 0, 2, {
"@   ", "\xdd   "}};
CIMAGE LRMIdiscofloor = { BG_NOCHANGE, FG_NOCHANGE, 0, 2, {
"   @", "   \xde"}};

CIMAGE Ldiscofloor1 = { BG_NOCHANGE, FG_NOCHANGE, 0, 2, {
"@   ", "\xdd  @"}};
CIMAGE Rdiscofloor1 = { BG_NOCHANGE, FG_NOCHANGE, 0, 2, {
"   @", "@  \xde"}};

CIMAGE discoballholder = { BG_NOCHANGE, FG_BLACK, 0, 1, {
"\xde\xdd"}};

CIMAGE discoball1 = { BG_NOCHANGE, FG_WHITE, 0, 5, {
"@@\xdc\xdb\xdb\xdc",
"@\xdb\xdb\xdb\xdb\xdb\xdb",
"\xde\xdb\xdb\xdb\xdb\xdb\xdb\xdd",
"@\xdb\xdb\xdb\xdb\xdb\xdb",
"@@\xdf\xdb\xdb\xdf"}};

CIMAGE discohighlight1 = { BG_WHITE, FG_LWHITE, 0, 4, {
"@@@@@@",
"@@\xb0\xb1\xb1\xb1",
"@@\xb0\xb0\xb1\xb1",
"@@\xb0\xb0\xb0\xb1"}};

CIMAGE discohighlight2 = { BG_WHITE, FG_LWHITE, 0, 4, {
"@@@@@@",
"@@\xb1\xb2\xb2\xb2",
"@@\xb1\xb1\xb2\xb2",
"@@\xb1\xb1\xb1\xb2"}};

char discodotlines[43][41] = {
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"};

CIMAGE discodots = { BG_NOCHANGE, FG_WHITE, 0, 43, {
discodotlines[0],discodotlines[1],discodotlines[2],discodotlines[3],discodotlines[4],
discodotlines[5],discodotlines[6],discodotlines[7],discodotlines[8],discodotlines[9],
discodotlines[10],discodotlines[11],discodotlines[12],discodotlines[13],discodotlines[14],
discodotlines[15],discodotlines[16],discodotlines[17],discodotlines[18],discodotlines[19],
discodotlines[20],discodotlines[21],discodotlines[22],discodotlines[23],discodotlines[24],
discodotlines[25],discodotlines[26],discodotlines[27],discodotlines[28],discodotlines[29],
discodotlines[30],discodotlines[31],discodotlines[32],discodotlines[33],discodotlines[34],
discodotlines[35],discodotlines[36],discodotlines[37],discodotlines[38],discodotlines[39],
discodotlines[40],discodotlines[41],discodotlines[42]}};

// Windows mode-related text
CIMAGE windows1 = { BG_WHITE, FG_BLUE, 1, 1, {
" Jvaqbjf "}};

CIMAGE windows2 = { BG_NOCHANGE, FG_LWHITE, 1, 12, {
"N sngny rkprcgvba 0R unf bppheerq ng",
"0028:P0011R36 va SVFUNEVHZ.RKR.  Gur",
"pheerag nccyvpngvba jvyy or grezvangrq.",
"",
"*@@Cerff nal xrl gb grezvangr gur",
"@@@pheerag nccyvpngvba.",
"*@@Cerff PGEY+NYG+QRY ntnva gb erfgneg",
"@@@lbhe pbzchgre.  Lbh jvyy ybfr nal",
"@@@hafnirq vasbezngvba va nyy",
"@@@nccyvpngvbaf.",
"",
"@@@@@@Cerff nal xrl gb pbagvahr "}};

CIMAGE windows3 = { BG_NOCHANGE, FG_WHITE, 1, 1, {
"_"}};

// Music-related text
char musicnotelines[5][21] = {
"@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@"};

CIMAGE musicnotes = { BG_NOCHANGE, FG_WHITE, 0, 5, {
musicnotelines[0],
musicnotelines[1],
musicnotelines[2],
musicnotelines[3],
musicnotelines[4]}};

CIMAGE musiclines = { BG_NOCHANGE, FG_WHITE, 0, 5, {
"\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4",
"\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4",
"\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4",
"\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4",
"\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xc4"}};


/**************************************************************************
* Clock-related functions
**************************************************************************/
DWORD getClock()
{
	return(GetTickCount());
}

DWORD startClock()
{
	return(startClockCount = getClock());
}

DWORD waitClock(DWORD count)
{
	// Wait for a specific number of ticks since call to startClock
	while ((getClock() - startClockCount) < count) continue;
	return(getClock());
}

/**************************************************************************
* makeLine: Fill in dots of path using Bresenham line algorithm
**************************************************************************/
void makeLine(COBJECT *obj, int x1, int y1, int x2, int y2) {
	int i, deltax, deltay, numpixels,
		d, dinc1, dinc2,
		x, xinc1, xinc2,
		y, yinc1, yinc2, result = 0, length = 0, index = 0;

	// Calculate deltax and deltay for initialisation
	deltax = abs(x2 - x1);
	deltay = abs(y2 - y1);

	// Initialize all vars based on which is the independent variable
	if (deltax >= deltay)
	{
		// x is independent variable
		numpixels = deltax + 1;
		d = (2 * deltay) - deltax;
		dinc1 = deltay << 1;
		dinc2 = (deltay - deltax) << 1;
		xinc1 = 1;
		xinc2 = 1;
		yinc1 = 0;
		yinc2 = 1;
	} else {
		// y is independent variable
		numpixels = deltay + 1;
		d = (2 * deltax) - deltay;
		dinc1 = deltax << 1;
		dinc2 = (deltax - deltay) << 1;
		xinc1 = 0;
		xinc2 = 1;
		yinc1 = 1;
		yinc2 = 1;
	}

	// Make sure x and y move in the right directions
	if (x1 > x2)
	{
		xinc1 = -xinc1;
		xinc2 = -xinc2;
	}
	if (y1 > y2)
	{
		yinc1 = -yinc1;
		yinc2 = -yinc2;
	}

	// Start drawing at
	x = x1;
	y = y1;

	// Draw the pixels
	for (i = 1; i <= numpixels; i++)
	{
		obj->path[index][0] = x;
		obj->path[index][1] = y;
		index++;
		if (d < 0)
		{
			d += dinc1;
			x += xinc1;
			y += yinc1;
		} else {
			d += dinc2;
			x += xinc2;
			y += yinc2;
		}
	}
	obj->path[index][0] = -1;
	obj->path[index][1] = -1;
}

/**************************************************************************
* clearScreen: Clear the character buffer
**************************************************************************/
void clearScreen()
{
	short i;
	for (i = 0; i < 80*50; i++) {
		chars[i].Char.AsciiChar = ' ';
		chars[i].Attributes = FG_WHITE;
	}
}

/**************************************************************************
* changeBGColour: Change background colour of a rectangular area
**************************************************************************/
void changeBGColour(DWORD col, int x, int y, int w, int h)
{
	int i, j;
	for (j = y; j < y+h; j++)
		for (i = x; i < x+w; i++)
		{
			chars[j*80+i].Attributes &= ~BG_WHITE;
			chars[j*80+i].Attributes |= col;
		}
}

/**************************************************************************
* changeFGColour: Change foreground colour of a rectangular area
**************************************************************************/
void changeFGColour(DWORD col, int x, int y, int w, int h)
{
	int i, j;
	for (j = y; j < y+h; j++)
		for (i = x; i < x+w; i++)
		{
			chars[j*80+i].Attributes &= ~FG_LWHITE;
			chars[j*80+i].Attributes |= col;
		}
}

/**************************************************************************
* drawCImage: Draw character image at a location
**************************************************************************/
void drawCImage(CIMAGE *img, int x, int y)
{
	char c;
	unsigned int i, j;
	for (j = 0; j < img->numlines; j++)
		for (i = 0; i < strlen(img->lines[j]); i++)
			if (img->lines[j][i] != '@')
			{
				if (img->BG != BG_NOCHANGE)
				{
					chars[(y+j)*80+x+i].Attributes &= ~BG_WHITE;
					chars[(y+j)*80+x+i].Attributes |= img->BG;
				}
				if (img->FG != FG_NOCHANGE)
				{
					chars[(y+j)*80+x+i].Attributes &= ~FG_LWHITE;
					chars[(y+j)*80+x+i].Attributes |= img->FG;
				}
				c = img->lines[j][i];
				if (img->rot13)
				{
					if ((c >= 65) && (c <= 90))
						c = ((c - 65 + 13) % 26) + 65;
					if ((c >= 97) && (c <= 122))
						c = ((c - 97 + 13) % 26) + 97;
				}
				chars[(y+j)*80+x+i].Char.AsciiChar = c;
			}
}

/**************************************************************************
* clearButtons: No more buttons
**************************************************************************/
void clearButtons()
{
	numbuttons = 0;
}

/**************************************************************************
* addButton: Add a button to check for
**************************************************************************/
void addButton(char hotkey, short x, short y, short width, short height, void (*function)())
{
	buttons[numbuttons].hotkey = hotkey;
	buttons[numbuttons].x = x;
	buttons[numbuttons].y = y;
	buttons[numbuttons].width = width;
	buttons[numbuttons].height = height;
	buttons[numbuttons].function = function;
	numbuttons++;
}

/**************************************************************************
* checkButtons: Given x,y, perform functions if button is there
**************************************************************************/
void checkButtons(short x, short y)
{
	short i;
	for (i = 0; i < numbuttons; i++)
		if ((x >= buttons[i].x) && (x <= buttons[i].x + buttons[i].width - 1) &&
			(y >= buttons[i].y) && (y <= buttons[i].y + buttons[i].height - 1))
			(*buttons[i].function)();
}

/**************************************************************************
* checkKeyButtons: Given a keycode, perform functions if applicable
**************************************************************************/
void checkKeyButtons(short keycode)
{
	short i;
	for (i = 0; i < numbuttons; i++)
		if (toupper((char)keycode) == toupper(buttons[i].hotkey))
			(*buttons[i].function)();
}

/**************************************************************************
* quit: Quit program
**************************************************************************/
void quit()
{
	done = 1;
}

/**************************************************************************
* titlebar1: User clicked on title bar 1
**************************************************************************/
void titlebar1()
{
	short i, j, titles[3];
	for (i = 0, j = 0; i < 4; i++)
		if (i != config.uimode)
			{ titles[j] = i; j++; }
	config.uimode = titles[0];
}

/**************************************************************************
* titlebar2: User clicked on title bar 2
**************************************************************************/
void titlebar2()
{
	short i, j, titles[3];
	for (i = 0, j = 0; i < 4; i++)
		if (i != config.uimode)
			{ titles[j] = i; j++; }
	config.uimode = titles[1];
}

/**************************************************************************
* titlebar3: User clicked on title bar 3
**************************************************************************/
void titlebar3()
{
	short i, j, titles[3];
	for (i = 0, j = 0; i < 4; i++)
		if (i != config.uimode)
			{ titles[j] = i; j++; }
	config.uimode = titles[2];
}

/**************************************************************************
* Functions to set display modes
**************************************************************************/
void setColour()	{ config.dispmode = COLOUR; }
void setBlackAndWhite() { config.dispmode = BLACKANDWHITE; }
void setDisco()		{ config.dispmode = DISCO; }
void setWindows()	{ config.dispmode = WINDOWS; }
void setMatrix()	{ config.dispmode = MATRIX; }
void toggleSound()	{ config.sound = !config.sound; }
void toggleMusic()	{ config.music = !config.music; }

/**************************************************************************
* Functions to set options
**************************************************************************/
void toggleAerator()	{ config.aerator = !config.aerator; }
void toggleCastle()		{ config.castle = !config.castle; }
void togglePlants()		{ config.plants = !config.plants; }
void toggleTreasure()	{ config.treasure = !config.treasure; }
void toggleTank()		{ config.tank = !config.tank; }

/**************************************************************************
* Functions to set play modes
**************************************************************************/
void setFeed()		{ config.actiontime = 300; config.playmode = FEED; }
void setSpeak()		{ config.actiontime = 150; config.playmode = SPEAK; }
void setPet()		{ config.actiontime = 150; config.playmode = PET; }
void setDance()		{ config.actiontime = 300; config.playmode = DANCE; }
void setSleep()		{ config.actiontime = 300; config.playmode = SLEEP; }
void setPlayDead()	{ config.actiontime = 300; config.playmode = PLAYDEAD; }

/**************************************************************************
* Functions to set torments
**************************************************************************/
void setNoTorment()		{ config.tormentmode = NOTHING; }
void setHeat()			{ config.tormentmode = HEAT; }
void setCold()			{ config.tormentmode = COLD; }
void setPoison()		{ config.tormentmode = POISON; }
void setLowerWater()	{ config.tormentmode = LOWERWATER; }

/**************************************************************************
* addStandardButtons: Add buttons regardless of UI mode
**************************************************************************/
void addStandardButtons()
{
	short i, j, titles[3];
	for (i = 0, j = 0; i < 4; i++)
		if (i != config.uimode)
			{ titles[j] = i; j++; }

	addButton(27, 76, 0, 3, 1, &quit);
	addButton((char)(titles[0]+'1'), 58, 1, 22, 1, &titlebar1);
	addButton((char)(titles[1]+'1'), 58, 2, 22, 1, &titlebar2);
	addButton((char)(titles[2]+'1'), 58, 3, 22, 1, &titlebar3);
}

/**************************************************************************
* runBlackAndWhiteFilter: Make it B&W
**************************************************************************/
void runBlackAndWhiteFilter()
{
	short i, j;
	static short linetime = 0, linepos = 0;
	for (i = 0; i < TANKWIDTH; i++)
		for (j = 0; j < TANKHEIGHT; j++)
		{
			if ((chars[80*j+i].Attributes & BG_WHITE) != 0)
				chars[j*80+i].Attributes |= BG_WHITE;
			if ((chars[80*j+i].Attributes & FOREGROUND_INTENSITY) != 0)
			{
				chars[j*80+i].Attributes &= ~FG_LWHITE;
				chars[j*80+i].Attributes |= FG_LWHITE;
			} else {
				chars[j*80+i].Attributes &= ~FG_LWHITE;
				chars[j*80+i].Attributes |= FG_BLACK;
			}
		}
	drawCImage(&noise[rand()%NUMNOISE],
		rand()%(TANKWIDTH/2)+1, rand()%(TANKHEIGHT-5));
	drawCImage(&noise[rand()%NUMNOISE],
		rand()%(TANKWIDTH/2)+(TANKWIDTH/2)-4, rand()%(TANKHEIGHT-5));

	if (linetime != 0)
	{
		for (i = 0; i < TANKHEIGHT-1; i++)
		{
			chars[i*80+linepos].Char.AsciiChar = (char)179;
			chars[i*80+linepos].Attributes &= ~FG_LWHITE;
		}
		linetime--;
	} else {
		// Start a line?
		if ((rand() % 5) == 0)
		{
			linepos = (rand() % (TANKWIDTH-2)) + 1;
			linetime = rand() % 3 + 1;
		}
	}
}

/**************************************************************************
* runMatrixFilter: Make it Matrixy
**************************************************************************/
void runMatrixFilter()
{
	short i, j;
	static short matrixCounts[TANKWIDTH] = {0};
	for (i = 0; i < TANKWIDTH; i++)
		for (j = 0; j < TANKHEIGHT; j++)
		{
			chars[j*80+i].Attributes = 0;
			if (chars[80*j+i].Char.AsciiChar == ' ')
				chars[j*80+i].Attributes |= FG_GREEN;
			else
				chars[j*80+i].Attributes |= FG_LGREEN;
			if (j == matrixPos[i])
				chars[j*80+i].Attributes |= FG_LGREEN;
			chars[80*j+i].Char.AsciiChar = WhatIsTheMatrix[j][i];
		}

	// Update
	for (i = 0; i < TANKWIDTH; i++)
	{
		if (matrixCounts[i] == 0)
		{
			WhatIsTheMatrix[matrixPos[i]][i] = (rand()%26)+97;
			matrixPos[i]++;
			if (matrixPos[i] >= TANKHEIGHT)
				matrixPos[i] = 0;
		}
		matrixCounts[i]--;
		if (matrixCounts[i] < 0)
			matrixCounts[i] = matrixSpeeds[i];
	}
}

/**************************************************************************
* makeFishLoc: Return random fish location in x, y
**************************************************************************/
void makeFishLoc(COBJECT *obj, short *x, short *y)
{
	bounds.top++; // Don't let fish go on top line.
	if (obj->image->numlines > 1) // big fish
	{
		*x = (short)((rand() % (bounds.right - bounds.left - 7 + 1)) + bounds.left);
		*y = (short)((rand() % (bounds.bottom - bounds.top - 4 + 1)) + bounds.top);
	} else {
		*x = (short)((rand() % (bounds.right - bounds.left - 4 + 1)) + bounds.left);
		*y = (short)((rand() % (bounds.bottom - bounds.top + 1)) + bounds.top);
	}
	bounds.top--;
}

/**************************************************************************
* makeFishRest: Set up fish as resting
**************************************************************************/
void makeFishRest(COBJECT *obj)
{
	obj->state = RESTING;
	obj->count = rand() % 100;
}

/**************************************************************************
* makeFishMove: Set up fish as moving
**************************************************************************/
void makeFishMove(COBJECT *obj)
{
	short dx, dy;
	obj->state = MOVING;
	obj->curpath = 0;
	obj->speed = rand() % 10;
	obj->count = obj->speed;
	do {
		makeFishLoc(obj, &dx, &dy);
	} while (((obj->dir == LEFT) && (dx > obj->x)) ||
			 ((obj->dir == RIGHT) && (dx < obj->x)));
	makeLine(obj, obj->x, obj->y, dx, dy);
}

/**************************************************************************
* makeFishTurn: Set up fish as turning
**************************************************************************/
void makeFishTurn(COBJECT *obj)
{
	obj->state = TURNING;
	obj->count = 4; // # frames
	obj->path[0][0] = rand()%3+5;		// timer. (bleah)
	obj->path[0][1] = obj->path[0][0];
}

/**************************************************************************
* drawDiscoStuff: Draw the disco stuff.  Stayin' alive!
**************************************************************************/
void drawDiscoStuff()
{
	short i, j;
	char dots[3] = "\xf9\xfa";

	for (i = 38; i >= 0; i--)
		for (j = 0; j < 43; j++)
			discodotlines[j][i+1] = discodotlines[j][i];
	for (i = 0; i < 43; i++)
		discodotlines[i][0] = '@';
	if ((frame % 5) == 0)
	{
		discodotlines[ 2-2][0] = dots[rand()%2];
		discodotlines[ 6-2][0] = dots[rand()%2];
		discodotlines[10-2][0] = dots[rand()%2];
		discodotlines[14-2][0] = dots[rand()%2];
		discodotlines[18-2][0] = dots[rand()%2];
		discodotlines[22-2][0] = dots[rand()%2];
		discodotlines[26-2][0] = dots[rand()%2];
		discodotlines[30-2][0] = dots[rand()%2];
		discodotlines[34-2][0] = dots[rand()%2];
		discodotlines[38-2][0] = dots[rand()%2];
		discodotlines[42-2][0] = dots[rand()%2];
	}
	if (((frame+3) % 5) == 0)
	{
		discodotlines[ 2][0] = dots[rand()%2];
		discodotlines[ 6][0] = dots[rand()%2];
		discodotlines[10][0] = dots[rand()%2];
		discodotlines[14][0] = dots[rand()%2];
		discodotlines[18][0] = dots[rand()%2];
		discodotlines[22][0] = dots[rand()%2];
		discodotlines[26][0] = dots[rand()%2];
		discodotlines[30][0] = dots[rand()%2];
		discodotlines[34][0] = dots[rand()%2];
		discodotlines[38][0] = dots[rand()%2];
		discodotlines[42][0] = dots[rand()%2];
	}

	drawCImage(&discodots, 9, 0);
	drawCImage(&discoballholder, TANKWIDTH/2-1, 0);
	drawCImage(&discoball1, TANKWIDTH/2-4, 1);
	if ((frame % 2) == 0)
		drawCImage(&discohighlight1, TANKWIDTH/2-4, 1);
	else
		drawCImage(&discohighlight2, TANKWIDTH/2-4, 1);

	if (((frame / 10) % 2) == 0) {
		// first row
		ULMIdiscofloor.FG = FG_RED;
		ULMIdiscofloor.BG = BG_GREEN;
		drawCImage(&ULMIdiscofloor, TANKWIDTH/2-3, TANKHEIGHT-5);
		URMIdiscofloor.FG = FG_GREEN;
		URMIdiscofloor.BG = BG_RED;
		drawCImage(&URMIdiscofloor, TANKWIDTH/2, TANKHEIGHT-5);

		Ldiscofloor1.FG = FG_GREEN;
		Ldiscofloor1.BG = BG_RED;
		drawCImage(&Ldiscofloor1, TANKWIDTH/2-3-3, TANKHEIGHT-5);
		Rdiscofloor1.FG = FG_RED;
		Rdiscofloor1.BG = BG_GREEN;
		drawCImage(&Rdiscofloor1, TANKWIDTH/2+2, TANKHEIGHT-5);

		Ldiscofloor1.FG = FG_BLACK;
		Ldiscofloor1.BG = BG_GREEN;
		drawCImage(&Ldiscofloor1, TANKWIDTH/2-3-3-3, TANKHEIGHT-5);
		Rdiscofloor1.FG = FG_BLACK;
		Rdiscofloor1.BG = BG_RED;
		drawCImage(&Rdiscofloor1, TANKWIDTH/2+2+3, TANKHEIGHT-5);

		// second row
		LLMIdiscofloor.FG = FG_YELLOW;
		LLMIdiscofloor.BG = BG_BLUE;
		drawCImage(&LLMIdiscofloor, TANKWIDTH/2-4, TANKHEIGHT-3);
		LRMIdiscofloor.FG = FG_BLUE;
		LRMIdiscofloor.BG = BG_YELLOW;
		drawCImage(&LRMIdiscofloor, TANKWIDTH/2, TANKHEIGHT-3);

		Ldiscofloor1.FG = FG_BLUE;
		Ldiscofloor1.BG = BG_YELLOW;
		drawCImage(&Ldiscofloor1, TANKWIDTH/2-3-3-1, TANKHEIGHT-3);
		Rdiscofloor1.FG = FG_YELLOW;
		Rdiscofloor1.BG = BG_BLUE;
		drawCImage(&Rdiscofloor1, TANKWIDTH/2+2+1, TANKHEIGHT-3);

		Ldiscofloor1.FG = FG_BLACK;
		Ldiscofloor1.BG = BG_BLUE;
		drawCImage(&Ldiscofloor1, TANKWIDTH/2-3-3-3-1, TANKHEIGHT-3);
		Rdiscofloor1.FG = FG_BLACK;
		Rdiscofloor1.BG = BG_YELLOW;
		drawCImage(&Rdiscofloor1, TANKWIDTH/2+2+3+1, TANKHEIGHT-3);
	} else {
		// first row
		ULMIdiscofloor.FG = FG_BLUE;
		ULMIdiscofloor.BG = BG_YELLOW;
		drawCImage(&ULMIdiscofloor, TANKWIDTH/2-3, TANKHEIGHT-5);
		URMIdiscofloor.FG = FG_YELLOW;
		URMIdiscofloor.BG = BG_BLUE;
		drawCImage(&URMIdiscofloor, TANKWIDTH/2, TANKHEIGHT-5);

		Ldiscofloor1.FG = FG_YELLOW;
		Ldiscofloor1.BG = BG_BLUE;
		drawCImage(&Ldiscofloor1, TANKWIDTH/2-3-3, TANKHEIGHT-5);
		Rdiscofloor1.FG = FG_BLUE;
		Rdiscofloor1.BG = BG_YELLOW;
		drawCImage(&Rdiscofloor1, TANKWIDTH/2+2, TANKHEIGHT-5);

		Ldiscofloor1.FG = FG_BLACK;
		Ldiscofloor1.BG = BG_YELLOW;
		drawCImage(&Ldiscofloor1, TANKWIDTH/2-3-3-3, TANKHEIGHT-5);
		Rdiscofloor1.FG = FG_BLACK;
		Rdiscofloor1.BG = BG_BLUE;
		drawCImage(&Rdiscofloor1, TANKWIDTH/2+2+3, TANKHEIGHT-5);

		// second row
		LLMIdiscofloor.FG = FG_GREEN;
		LLMIdiscofloor.BG = BG_RED;
		drawCImage(&LLMIdiscofloor, TANKWIDTH/2-4, TANKHEIGHT-3);
		LRMIdiscofloor.FG = FG_RED;
		LRMIdiscofloor.BG = BG_GREEN;
		drawCImage(&LRMIdiscofloor, TANKWIDTH/2, TANKHEIGHT-3);

		Ldiscofloor1.FG = FG_RED;
		Ldiscofloor1.BG = BG_GREEN;
		drawCImage(&Ldiscofloor1, TANKWIDTH/2-3-3-1, TANKHEIGHT-3);
		Rdiscofloor1.FG = FG_GREEN;
		Rdiscofloor1.BG = BG_RED;
		drawCImage(&Rdiscofloor1, TANKWIDTH/2+2+1, TANKHEIGHT-3);

		Ldiscofloor1.FG = FG_BLACK;
		Ldiscofloor1.BG = BG_RED;
		drawCImage(&Ldiscofloor1, TANKWIDTH/2-3-3-3-1, TANKHEIGHT-3);
		Rdiscofloor1.FG = FG_BLACK;
		Rdiscofloor1.BG = BG_GREEN;
		drawCImage(&Rdiscofloor1, TANKWIDTH/2+2+3+1, TANKHEIGHT-3);
	}
}

/**************************************************************************
* drawAerator: Draw the aerator
**************************************************************************/
void drawAerator()
{
	short i, j;
	char dots[4] = ".oO";

	// Move up
	for (i = 0; i < 5; i++)
		for (j = 0; j < 43; j++)
			aeratorlines[j][i] = aeratorlines[j+1][i];
	// Clear bottom line
	for (i = 0; i < 5; i++)
		aeratorlines[42][i] = '@';
	// "Jostle" bubbles
	for (j = 0; j < 42; j++)
	{
		if (rand()%3 != 0)
		{
			if (aeratorlines[j][0] != '@')
			{
				aeratorlines[j][1] = aeratorlines[j][0];
				aeratorlines[j][0] = '@';
				continue;
			}
			if (aeratorlines[j][4] != '@')
			{
				aeratorlines[j][3] = aeratorlines[j][4];
				aeratorlines[j][4] = '@';
				continue;
			}
			for (i = 1; i < 4; i++)
			{
				if (aeratorlines[j][i] != '@')
				{
					if ((rand() % 2) == 0)
						aeratorlines[j][i+1] = aeratorlines[j][i];
					else
						aeratorlines[j][i-1] = aeratorlines[j][i];
					aeratorlines[j][i] = '@';
					break;
				}
			}
		}
	}
	// Add bubble
	if ((rand() % 3) != 0)
		aeratorlines[42][(rand()%3)+1] = dots[rand()%3];
	// If water is lowered, clear out some bubbles
	for (i = 0; i < lowerwaterheight; i++)
		for (j = 0; j < 5; j++)
			aeratorlines[i][j] = '@';

	drawCImage(&aerator, 10, 0);
}

/**************************************************************************
* pickSpeech: Pick something for fishies to say
**************************************************************************/
void pickSpeech(SPEECHES *speeches)
{
	unsigned short i, speech;
	if (speeches->speechesleft == 0)
	{
		speeches->speechesleft = speeches->numspeeches;
		for (i = 0; i < speeches->numspeeches; i++)
			speeches->said[i] = 0;
	}

	do {
		speech = rand()%speeches->numspeeches;
	} while (speeches->said[speech] == 1);

	speeches->said[speech] = 1;
	speak1text.FG = speak2text.FG = fishclrs[rand()%5];
	if (speeches->lines[speech][0][0] == '0')
		speechflag = DONTWAIT;
	else if (speeches->lines[speech][0][0] == '1')
	{
		speechflag = WAIT;
		do {
			speak2text.FG = fishclrs[rand()%5];
		} while (speak1text.FG == speak2text.FG);
	}

	for (i = 0; i < (TANKWIDTH-strlen(speeches->lines[speech][0])+1)/2; i++)
		speak1chrs[i] = ' ';
	speak1chrs[i] = 0;
	strcat(speak1chrs, &speeches->lines[speech][0][1]);

	for (i = 0; i < (TANKWIDTH-strlen(speeches->lines[speech][1]))/2; i++)
		speak2chrs[i] = ' ';
	speak2chrs[i] = 0;
	strcat(speak2chrs, speeches->lines[speech][1]);

	speeches->speechesleft--;
}

/**************************************************************************
* doFishies: Do most of the fish work
**************************************************************************/
void doFishies()
{
	int i, j;
	static char chr = 65;
	static short eyecount = 0;
	static short lowercount = 0;
	static short heatdotlocs[12][2] = {
		{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},
		{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}};
	CIMAGE *titles[4] = {&display, &options, &play, &torment};

	clearScreen();

	// Adjust water height if needed
	if (config.tormentmode == LOWERWATER)
	{
		if (lowercount != 0) {
			lowercount--;
		} else {
			lowercount = 7;
			if (lowerwaterheight < 35)
				lowerwaterheight++;
		}
	} else {
		lowercount = 0;
		lowerwaterheight = 0;
	}
	bounds.top = lowerwaterheight;

	// Draw empty tank
	if (config.tormentmode == POISON)
		changeBGColour(BG_GREEN, 1, lowerwaterheight, TANKWIDTH-2, TANKHEIGHT-1-lowerwaterheight);
	else
		changeBGColour(BG_BLUE, 1, lowerwaterheight, TANKWIDTH-2, TANKHEIGHT-1-lowerwaterheight);
	chars[(TANKHEIGHT-1)*80].Char.AsciiChar = (char)192; //lowleft
	chars[(TANKHEIGHT-1)*80+TANKWIDTH-1].Char.AsciiChar = (char)217; //lowright

	// Left/right sides
	for (i = 0; i < TANKHEIGHT-1; i++)
	{
		chars[i*80].Char.AsciiChar = (char)179; // vertpipe
		chars[i*80+TANKWIDTH-1].Char.AsciiChar = (char)179;
	}
	// Bottom side
	for (i = 1; i < TANKWIDTH-1; i++)
		chars[(TANKHEIGHT-1)*80+i].Char.AsciiChar = (char)196; //horizpipe

	// Inside (back) left/right sides
	for (i = 0; i < TANKHEIGHT-5; i++)
	{
		chars[i*80+8].Attributes |= FG_WHITE;
		chars[i*80+8].Char.AsciiChar = (char)179; // vertpipe
		chars[i*80+TANKWIDTH-9].Attributes |= FG_WHITE;
		chars[i*80+TANKWIDTH-9].Char.AsciiChar = (char)179;
	}

	// Draw tank floor
	changeBGColour(BG_BLACK, 9, TANKHEIGHT-5, TANKWIDTH-18, 4);
	drawCImage(&leftfloor1, 1, TANKHEIGHT-5);
	drawCImage(&leftfloor2, 1, TANKHEIGHT-5);
	drawCImage(&rightfloor1, TANKWIDTH-9, TANKHEIGHT-5);
	drawCImage(&rightfloor2, TANKWIDTH-9, TANKHEIGHT-5);
	for (i = 9; i < TANKWIDTH-9; i++)
	{
		chars[(TANKHEIGHT-5)*80+i].Attributes = BG_BLACK | FG_BLACK;
		chars[(TANKHEIGHT-5)*80+i].Char.AsciiChar = (char)0xdb; //solidchar
	}

	// Disco mode
	if (config.dispmode == DISCO)
		drawDiscoStuff();

	// Windows mode
	if (config.dispmode == WINDOWS)
	{
		drawCImage(&windows1, 24, 6+8);
		drawCImage(&windows2, 10, 8+8);
		drawCImage(&windows3, 42,19+8);
	}

	// Aerator is on
	if (config.aerator)
		drawAerator();

	// Heat torment is on
	if (config.tormentmode == HEAT)
	{
		for (i = 0; i < 12; i++)
		{
			// Lower water and heat are mutex, but just in case
			if (heatdotlocs[i][1] < lowerwaterheight)
				heatdotlocs[i][1] = -1;
			if (heatdotlocs[i][1] == -1)
			{
				heatdotlocs[i][0] = rand()%(TANKWIDTH-2);
				heatdotlocs[i][1] = rand()%(TANKHEIGHT-7);
			}
		}
		for (i = 0; i < 43; i++)
			strcpy(heatdotlines[i], "@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
		for (i = 0; i < 12; i++)
		{
			heatdotlines[heatdotlocs[i][1]][heatdotlocs[i][0]] = 'o';
			heatdotlocs[i][1]--;
		}
		// If water is lowered, clear out some bubbles
		for (i = 0; i < lowerwaterheight; i++)
			for (j = 0; j < TANKWIDTH-2; j++)
				heatdotlines[i][j] = '@';
		drawCImage(&heatdots, 1, 0);
	}

	// Draw UI window
	changeBGColour(BG_WHITE, 58, 1, 22, WINDOWHEIGHT);
	changeFGColour(FG_BLACK, 58, 1, 22, WINDOWHEIGHT);
	chars[(WINDOWHEIGHT)*80+TANKWIDTH].Char.AsciiChar = (char)200; //lowleft
	chars[(WINDOWHEIGHT)*80+79].Char.AsciiChar = (char)188; //lowright

	for (i = 1; i < WINDOWHEIGHT; i++)
	{
		chars[i*80+TANKWIDTH].Char.AsciiChar = (char)186; //dblvertpipe
		chars[i*80+79].Char.AsciiChar = (char)186; //dblvertpipe
	}
	for (i = TANKWIDTH+1; i < 80-1; i++)
		chars[(WINDOWHEIGHT)*80+i].Char.AsciiChar = (char)205; //dblhorizpipe

	drawCImage(&title, 59, 0);
	changeFGColour(FG_LRED, 77, 0, 1, 1);
	drawCImage(&topwindow, 58, 1);
	drawCImage(&topwindow, 58, 2);
	drawCImage(&topwindow, 58, 3);
	drawCImage(&dbltopwindow, 58, 4);

	// Draw UI options
	drawCImage(titles[config.uimode], 63, 4);
	for (i = 0, j = 1; i < 4; i++)
		if (i != config.uimode)
		{
			drawCImage(titles[i], 59+j, j);
			j++;
		}

	clearButtons();
	addStandardButtons();
	changeFGColour(FG_LWHITE, 61, 1, 1, 1);
	changeFGColour(FG_LWHITE, 62, 2, 1, 1);
	changeFGColour(FG_LWHITE, 63, 3, 1, 1);
	changeFGColour(FG_LWHITE, 64, 4, 1, 1);

	if (config.uimode == DISPLAY)
	{
		drawCImage(&Dcolour, 60, 6);
		drawCImage(&Dblackandwhite, 60, 7);
		drawCImage(&Ddisco, 60, 8);
		drawCImage(&Dwindows, 60, 9);
		drawCImage(&Dmatrix, 60, 10);
		drawCImage(&Dsound, 60, 12);
		drawCImage(&Dmusic, 60, 13);
		changeFGColour(FG_LWHITE, 64, 6, 1, 4);
		changeFGColour(FG_LWHITE, 69,10, 1, 1);
		changeFGColour(FG_LWHITE, 64,12, 1, 2);

		if (config.dispmode == COLOUR)				drawCImage(&dot, 61, 6);
		else if (config.dispmode == BLACKANDWHITE)	drawCImage(&dot, 61, 7);
		else if (config.dispmode == DISCO)			drawCImage(&dot, 61, 8);
		else if (config.dispmode == WINDOWS)		drawCImage(&dot, 61, 9);
		else if (config.dispmode == MATRIX)			drawCImage(&dot, 61, 10);
		if (config.sound)	drawCImage(&theX, 61, 12);
		if (config.music)	drawCImage(&theX, 61, 13);

		addButton('C', 60, 6, 18, 1, &setColour);
		addButton('B', 60, 7, 18, 1, &setBlackAndWhite);
		addButton('D', 60, 8, 18, 1, &setDisco);
		addButton('W', 60, 9, 18, 1, &setWindows);
		addButton('X', 60,10, 18, 1, &setMatrix);
		addButton('S', 60,12, 18, 1, &toggleSound);
		addButton('M', 60,13, 18, 1, &toggleMusic);
	}

	if (config.uimode == OPTIONS)
	{
		drawCImage(&Daerator, 60, 6);
		drawCImage(&Dcastle, 60, 7);
		drawCImage(&Dplants, 60, 8);
		drawCImage(&Dtreasure, 60, 9);
		drawCImage(&Dtank, 60, 10);
		changeFGColour(FG_LWHITE, 64, 6, 1, 4);
		changeFGColour(FG_LWHITE, 67,10, 1, 1);

		if (config.aerator)			drawCImage(&theX, 61, 6);
		if (config.castle)			drawCImage(&theX, 61, 7);
		if (config.plants)			drawCImage(&theX, 61, 8);
		if (config.treasure)		drawCImage(&theX, 61, 9);
		if (config.tank)			drawCImage(&theX, 61, 10);

		addButton('A', 60, 6, 18, 1, &toggleAerator);
		addButton('C', 60, 7, 18, 1, &toggleCastle);
		addButton('P', 60, 8, 18, 1, &togglePlants);
		addButton('T', 60, 9, 18, 1, &toggleTreasure);
		addButton('K', 60,10, 18, 1, &toggleTank);
	}

	if (config.uimode == PLAY)
	{
		drawCImage(&Pfeed, 63, 6);
		drawCImage(&Pspeak, 63, 8);
		drawCImage(&Ppet, 63, 10);
		drawCImage(&Pdance, 63, 12);
		drawCImage(&Psleep, 63, 14);
		drawCImage(&Pplaydead, 63, 16);

		if (config.actiontime == 0)
		{
			changeFGColour(FG_LWHITE, 66, 6, 1, 1);
			changeFGColour(FG_LWHITE, 66, 8, 1, 1);
			changeFGColour(FG_LWHITE, 69, 10, 1, 1);
			changeFGColour(FG_LWHITE, 66, 12, 1, 1);
			changeFGColour(FG_LWHITE, 67, 14, 1, 1);
			changeFGColour(FG_LWHITE, 64, 16, 1, 1);

			addButton('F', 63, 6, 11, 1, &setFeed);
			addButton('S', 63, 8, 11, 1, &setSpeak);
			addButton('T', 63,10, 11, 1, &setPet);
			addButton('D', 63,12, 11, 1, &setDance);
			addButton('L', 63,14, 11, 1, &setSleep);
			addButton('P', 63,16, 11, 1, &setPlayDead);
		} else {
			if (config.playmode == FEED)			drawCImage(&dot, 61, 6);
			else if (config.playmode == SPEAK)		drawCImage(&dot, 61, 8);
			else if (config.playmode == PET)		drawCImage(&dot, 61, 10);
			else if (config.playmode == DANCE)		drawCImage(&dot, 61, 12);
			else if (config.playmode == SLEEP)		drawCImage(&dot, 61, 14);
			else if (config.playmode == PLAYDEAD)	drawCImage(&dot, 61, 16);
		}
	}

	if (config.uimode == TORMENT)
	{
		drawCImage(&Tnothing, 60, 6);
		drawCImage(&Theat, 60, 7);
		drawCImage(&Tcold, 60, 8);
		drawCImage(&Tpoison, 60, 9);
		drawCImage(&Tlowerwater, 60, 10);
		changeFGColour(FG_LWHITE, 64, 6, 1, 5);

		if (config.tormentmode == NOTHING)			drawCImage(&dot, 61, 6);
		else if (config.tormentmode == HEAT)		drawCImage(&dot, 61, 7);
		else if (config.tormentmode == COLD)		drawCImage(&dot, 61, 8);
		else if (config.tormentmode == POISON)		drawCImage(&dot, 61, 9);
		else if (config.tormentmode == LOWERWATER)	drawCImage(&dot, 61, 10);

		addButton('N', 60, 6, 18, 1, &setNoTorment);
		addButton('H', 60, 7, 18, 1, &setHeat);
		addButton('C', 60, 8, 18, 1, &setCold);
		addButton('P', 60, 9, 18, 1, &setPoison);
		addButton('L', 60,10, 18, 1, &setLowerWater);
	}

	if (!config.sound)
		drawCImage(&mute, (TANKWIDTH-8)/2, 48);

	// Draw stuff
	if (config.music)
	{
		char notes[5] = "\x07\x09\x0d\x0e";
		if ((frame % 2) == 1)
		{
			for (i = 0; i < 19; i++)
				for (j = 0; j < 5; j++)
					musicnotelines[j][i] = musicnotelines[j][i+1];
			for (i = 0; i < 5; i++)
				musicnotelines[i][19] = '@';
			if ((frame % 4) == 1)
				musicnotelines[rand()%5][19] = notes[rand()%4];
		}
		drawCImage(&musiclines, 59, 28);
		drawCImage(&musicnotes, 59, 28);
	}

	// Move fish
	for (i = 0; i < 5; i++)
	{
		if (fishes[i].state == RESTING)
		{
			if (fishes[i].count != 0)
				fishes[i].count--;
			else
				makeFishMove(&fishes[i]);
		} else if (fishes[i].state == MOVING) {
			if (fishes[i].count != 0)
				fishes[i].count--;
			else
			{
				fishes[i].count = fishes[i].speed;
				fishes[i].curpath++;
				if (fishes[i].path[fishes[i].curpath][0] == -1)
				{
					if ((fishes[i].x < 4) ||
						(fishes[i].x + strlen(fishes[i].image->lines[0]) > TANKWIDTH-5))
						makeFishTurn(&fishes[i]);
					else if (rand() % 10 == 1)
						makeFishTurn(&fishes[i]);
					else if (rand() % 4 == 1)
						makeFishRest(&fishes[i]);
					else
						makeFishMove(&fishes[i]);
				} else {
					fishes[i].x = fishes[i].path[fishes[i].curpath][0];
					fishes[i].y = fishes[i].path[fishes[i].curpath][1];
				}
			}
		} else if (fishes[i].state == TURNING) {
			if (fishes[i].path[0][0] != 0)
				fishes[i].path[0][0]--;
			else
			{
				fishes[i].count--;
				fishes[i].path[0][0] = fishes[i].path[0][1];
				if (fishes[i].dir == LEFT)
				{
					if (fishes[i].count == 3)
						fishes[i].image = (i < 3) ? &lfish1 : &slfish1;
					else if (fishes[i].count == 2)
						fishes[i].image = (i < 3) ? &lfish2 : &slfish2;
					else if (fishes[i].count == 1)
						fishes[i].image = (i < 3) ? &lfish3 : &slfish3;
					else if (fishes[i].count == 0)
					{
						fishes[i].image = (i < 3) ? &rfish  : &srfish;
						fishes[i].dir = RIGHT;
						if (rand() % 4 == 1)
							makeFishRest(&fishes[i]);
						else
							makeFishMove(&fishes[i]);
					}
				} else {
					if (fishes[i].count == 3)
						fishes[i].image = (i < 3) ? &rfish1 : &srfish1;
					else if (fishes[i].count == 2)
						fishes[i].image = (i < 3) ? &rfish2 : &srfish2;
					else if (fishes[i].count == 1)
						fishes[i].image = (i < 3) ? &rfish3 : &srfish3;
					else if (fishes[i].count == 0)
					{
						fishes[i].image = (i < 3) ? &lfish  : &slfish;
						fishes[i].dir = LEFT;
						if (rand() % 4 == 1)
							makeFishRest(&fishes[i]);
						else
							makeFishMove(&fishes[i]);
					}
				}
			}
		}
	}

	// Keep fish in bounds
	for (i = 0; i < 5; i++)
	{
		while (fishes[i].x < bounds.left)
			fishes[i].x++;
		while (fishes[i].y < bounds.top)
			fishes[i].y++;
		if (i < 3) // big fish
		{
			while (fishes[i].x+7 > bounds.right)
				fishes[i].x--;
			while (fishes[i].y+4 > bounds.bottom)
				fishes[i].y--;
		} else {
			while (fishes[i].x+4 > bounds.right)
				fishes[i].x--;
			while (fishes[i].y+1 > bounds.bottom)
				fishes[i].y--;
		}
	}

	// Do fish stuff
	if (config.actiontime == 0)
		config.playmode = NOTHING;
	else
	{
		unsigned short dx;

		if (config.playmode == PET)
		{
			if (config.sound)
			{
				speaktime = 0; silencetime = rand()%300+200;
				if (config.actiontime == 150)
					Ppettext.FG = fishclrs[rand()%5];
				drawCImage(&Ppettext, 8, 48);
			}
		} else if (config.playmode == SPEAK) {
			if (config.sound)
			{
				speaktime = 0; silencetime = rand()%300+200;
				for (i = 0; i < 5; i++)
				{
					Pspeaktext.FG = fishclrs[i];
					drawCImage(&Pspeaktext, 6*i+14, 48);
				}
			}
		} else if (config.playmode == SLEEP) {
			if (config.sound)
			{
				speaktime = 0; silencetime = rand()%300+200;
				for (i = 0; i < 5; i++)
				{
					Psleeptext.FG = fishclrs[i];
					drawCImage(&Psleeptext, 7*i+12, 48);
				}
			}
			for (i = 0; i < 5; i++)
				if (fishes[i].state != TURNING)
					fishes[i].state = RESTING;
		} else if (config.playmode == FEED) {
			if (config.sound)
			{
				speaktime = 0; silencetime = rand()%300+200;
				for (i = 0; i < 5; i++)
				{
					Pfeedtext.FG = fishclrs[i];
					drawCImage(&Pfeedtext, 5*i+17, 48);
				}
			}
			if (config.actiontime == 300)
			{
				for (i = 0; i < 5; i++)
				{
					fishes[i].state = MOVING;
					fishes[i].curpath = 0;
					fishes[i].speed = 2;
					fishes[i].count = fishes[i].speed;
					dx = TANKHEIGHT/2+(rand()%7)-4;

					if ((fishes[i].dir == LEFT) && (dx > fishes[i].x))
						fishes[i].dir = RIGHT;
					else if ((fishes[i].dir == RIGHT) && (dx < fishes[i].x))
						fishes[i].dir = LEFT;

					if (i < 3) // big fish
					{
						if (fishes[i].dir == LEFT)
							fishes[i].image = &lfish;
						else
							fishes[i].image = &rfish;
					} else {
						if (fishes[i].dir == LEFT)
							fishes[i].image = &slfish;
						else
							fishes[i].image = &srfish;
					}
					makeLine(&fishes[i], fishes[i].x, fishes[i].y, dx, 0);
				}
			} else {
				for (i = 0; i < 5; i++)
					if (fishes[i].y == lowerwaterheight)
						fishes[i].state = RESTING;
			}
		} else if (config.playmode == PLAYDEAD) {
			if (config.actiontime == 300)
			{
				for (i = 0; i < 5; i++)
				{
					if (i < 3) // big fish
					{
						if (fishes[i].dir == LEFT)
							fishes[i].image = &dlfish;
						else
							fishes[i].image = &drfish;
					}
					fishes[i].state = MOVING;
					fishes[i].curpath = 0;
					fishes[i].speed = 2;
					fishes[i].count = fishes[i].speed;
					makeLine(&fishes[i], fishes[i].x, fishes[i].y, fishes[i].x, 0);
				}
			} else {
				for (i = 0; i < 5; i++)
					if (fishes[i].y == lowerwaterheight)
						fishes[i].state = RESTING;
			}
			if (config.actiontime == 1) {
				for (i = 0; i < 3; i++) // reset big fish images
					if (fishes[i].dir == LEFT)
						fishes[i].image = &lfish;
					else
						fishes[i].image = &rfish;
			}
		} else if (config.playmode == DANCE){ 
			for (i = 0; i < 5; i++)
				if (fishes[i].state != TURNING)
				{
					if (((config.actiontime / 5) % 2) == 1) {
						//invert pics
						if (i < 3) // big fish
						{
							if (fishes[i].dir == LEFT)
								fishes[i].image = &rfish;
							else
								fishes[i].image = &lfish;
						} else {
							if (fishes[i].dir == LEFT)
								fishes[i].image = &srfish;
							else
								fishes[i].image = &slfish;
						}
					} else {
						//normal pics
						if (i < 3) // big fish
						{
							if (fishes[i].dir == LEFT)
								fishes[i].image = &lfish;
							else
								fishes[i].image = &rfish;
						} else {
							if (fishes[i].dir == LEFT)
								fishes[i].image = &slfish;
							else
								fishes[i].image = &srfish;
						}
					}
				}
		}
		config.actiontime--;
	}

	// Draw fish and stuff
	if (config.tormentmode == COLD)
		fishes[4].image->FG = FG_LBLUE;
	else
		fishes[4].image->FG = fishes[4].FG;
	drawCImage(fishes[4].image, fishes[4].x, fishes[4].y);

	if (config.tank)	drawCImage(&Otank, 19, 40);

	if (config.tormentmode == COLD)
		fishes[3].image->FG = FG_LBLUE;
	else
		fishes[3].image->FG = fishes[3].FG;
	drawCImage(fishes[3].image, fishes[3].x, fishes[3].y);

	if (config.castle)
	{
		drawCImage(&Ocastle1, 37, 39);
		drawCImage(&Ocastle2, 37, 39);
		if (rand() % 500 == 0)
			eyecount = 30;
		if (eyecount)
		{
			drawCImage(&Ocastle3, 37, 39);
			eyecount--;
		}
	}

	if (config.tormentmode == COLD)
		fishes[2].image->FG = FG_LBLUE;
	else
		fishes[2].image->FG = fishes[2].FG;
	drawCImage(fishes[2].image, fishes[2].x, fishes[2].y);

	if (config.tormentmode == COLD)
		fishes[1].image->FG = FG_LBLUE;
	else
		fishes[1].image->FG = fishes[1].FG;
	drawCImage(fishes[1].image, fishes[1].x, fishes[1].y);

	if (config.treasure)
	{
		drawCImage(&Otreasure1, 10, 41);
		drawCImage(&Otreasure2, 10, 41);
	}

	if (config.tormentmode == COLD)
		fishes[0].image->FG = FG_LBLUE;
	else
		fishes[0].image->FG = fishes[0].FG;
	drawCImage(fishes[0].image, fishes[0].x, fishes[0].y);

	if (config.plants)	drawCImage(&Oplants, 0, 42);

	// Filter display
	if (config.dispmode == BLACKANDWHITE)
		runBlackAndWhiteFilter();
	if (config.dispmode == MATRIX)
		runMatrixFilter();

	// Say stuff if applicable
	if (silencetime > 0)
		silencetime--;
	else if (speaktime == 0)
	{
		// Pick thing
		if ((config.dispmode == BLACKANDWHITE) &&
			((rand()%100) < fishspeeches[0].probability))
			pickSpeech(&fishspeeches[0]);
		else if ((config.dispmode == WINDOWS) &&
				 ((rand()%100) < fishspeeches[1].probability))
			pickSpeech(&fishspeeches[1]);
		else if ((config.dispmode == MATRIX) &&
				 ((rand()%100) < fishspeeches[2].probability))
			pickSpeech(&fishspeeches[2]);
		else if ((config.tormentmode == HEAT) &&
				 ((rand()%100) < fishspeeches[3].probability))
				pickSpeech(&fishspeeches[3]);
		else if ((config.tormentmode == COLD) &&
				 ((rand()%100) < fishspeeches[4].probability))
				pickSpeech(&fishspeeches[4]);
		else if ((config.treasure) &&
				 ((rand()%100) < fishspeeches[5].probability))
			pickSpeech(&fishspeeches[5]);
		else
			pickSpeech(&fishspeeches[6]);
		speaktime = 300;
	}

	if (speaktime > 0)
	{
		if (config.sound)
		{
			drawCImage(&speak1text, 0, 48);
			if ((speechflag == DONTWAIT) || (speaktime < 200))
				drawCImage(&speak2text, 0, 49);
		}
		// show thing
		speaktime--;
		if (speaktime == 0)
			silencetime = rand()%300+200;
	}

	// Test stuff
//	chars[0].Char.AsciiChar = chr; chr++; if (chr == 65 + 26) chr = 65;
//	for (i = 0; i < 256; i++) chars[i].Char.AsciiChar = i;

	// Write to display
	WriteConsoleOutput(whnd, (const CHAR_INFO *)(&chars),
		coord, coord2, &write);
}

/**************************************************************************
* main: Go go gadget fishies!
**************************************************************************/
int main(int argc, char* argv[])
{
	short mouseflag = 0;
	unsigned short i, j;
	DWORD num, cNumRead;//, fdwMode, fdwSaveOldMode;
	INPUT_RECORD irInBuf[128];
	SMALL_RECT rect = {0, 0, 79, 49};
	CONSOLE_CURSOR_INFO cursorinfo;
	COORD coord = {80, 50};
//	char *c;

	// Init stuff
	srand(time(NULL));
	for (j = 0; j < TANKHEIGHT; j++)
		for (i = 0; i < TANKWIDTH; i++)
			WhatIsTheMatrix[j][i] = (rand()%26)+97;
	for (i = 0; i < TANKWIDTH; i++)
	{
		matrixSpeeds[i] = rand() % 4;
		matrixPos[i] = rand() % TANKHEIGHT;
	}
/*
struct cobject {
	short state;	// resting/moving/turning
	short dir;		// direction of fish
	short x, y;		// x, y location
	short priority;	// low = back, high = front
	short curpath;
	short BG, FG;	// colours (override cimage)
	short path[80][2]; // -1, -1 = end
	CIMAGE *image;
};
*/
	for (i = 0; i < 5; i++)
	{
		makeFishLoc(&fishes[i], &fishes[i].x, &fishes[i].y);
		fishes[i].dir = rand()%2; // left/right
		fishes[i].state = rand()%2; // resting/moving
		if (fishes[i].state == RESTING)
			makeFishRest(&fishes[i]);
		else
			makeFishMove(&fishes[i]);

		if (i < 3) // big fish
		{
			if (fishes[i].dir == LEFT)
				fishes[i].image = &lfish;
			else
				fishes[i].image = &rfish;
		} else {
			if (fishes[i].dir == LEFT)
				fishes[i].image = &slfish;
			else
				fishes[i].image = &srfish;
		}
//		if (i == 4) makeFishTurn(&fishes[i]);
	}

	// Initialize window
	rhnd = GetStdHandle(STD_INPUT_HANDLE);
	whnd = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleWindowInfo(whnd, TRUE, &rect);
	SetConsoleScreenBufferSize(whnd, coord);
	SetConsoleTitle("Fisharium v1.0 by Tim Park");
	GetConsoleCursorInfo(whnd, &cursorinfo);
	cursorinfo.bVisible = FALSE;
	SetConsoleCursorInfo(whnd, &cursorinfo);
	if (!SetConsoleMode(rhnd, ENABLE_WINDOW_INPUT | ENABLE_MOUSE_INPUT))
		exit(2);

	// Loop to do stuff and read and handle the input events
	while (!done)
	{
		startClock();
		doFishies();

		// Wait for the events.
		cNumRead = 0;
		GetNumberOfConsoleInputEvents(rhnd, &num);
		if (num != 0)
		{
			if (!ReadConsoleInput(
				rhnd,		// input buffer handle
				irInBuf,	// buffer to read into
				128,		// size of read buffer
				&cNumRead))	// number of records read
				;//exit(1);//	MyErrorExit("ReadConsoleInput");
		}

		// Dispatch the events to the appropriate handler.
		for (i = 0; i < cNumRead; i++)
		{
			switch(irInBuf[i].EventType)
			{
				case KEY_EVENT: // keyboard input
					if (irInBuf[i].Event.KeyEvent.bKeyDown == FALSE)
						checkKeyButtons(irInBuf[i].Event.KeyEvent.uChar.AsciiChar);
					break;

				case MOUSE_EVENT: // mouse input // right: RIGHTMOST_BUTTON_PRESSED
					if ((irInBuf[i].Event.MouseEvent.dwButtonState & FROM_LEFT_1ST_BUTTON_PRESSED) != 0)
						mouseflag = 1;
					if (mouseflag && ((irInBuf[i].Event.MouseEvent.dwButtonState & FROM_LEFT_1ST_BUTTON_PRESSED) == 0))
					{
						mouseflag = 0;
						checkButtons(
							irInBuf[i].Event.MouseEvent.dwMousePosition.X,
							irInBuf[i].Event.MouseEvent.dwMousePosition.Y);
					}
					break;

				default:
					break;
			}
		}
		waitClock(1000/30); //appx 30fps
		frame++;
	}

	clearScreen();
	WriteConsoleOutput(whnd, (const CHAR_INFO *)(&chars),
		coord, coord2, &write);
	cursorinfo.bVisible = TRUE;
	SetConsoleCursorInfo(whnd, &cursorinfo);
	return 0;
}
/*************************************************************************/
